import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.Random;
import Drawnings.*;
import MovementStrategy.*;

public class FormAirbus extends JFrame {

    private DrawingAirbus _drawningAirbus;
    private Canvas canvas = new Canvas();

    JLabel labelCount = new JLabel("Введите число иллюминаторов:");
    private JTextField fieldCount = new JTextField();
    private JButton buttonCreate;
    private JButton buttonUp;
    private JButton buttonDown;
    private JButton buttonRight;
    private JButton buttonLeft;

    public FormAirbus() {
        super("Создание самолёта");
        InitializeComponent();
        setVisible(true);
    }

    private void InitializeComponent()
    {
        buttonCreate = new JButton("Создать самолёт");

        buttonUp = new JButton();
        buttonUp.setName("up");
        buttonUp.setIcon(new ImageIcon("images\\KeyUp.png"));
        buttonUp.setSize(48, 44);

        buttonRight = new JButton();
        buttonRight.setName("right");
        buttonRight.setIcon(new ImageIcon("images\\KeyRight.png"));
        buttonRight.setSize(48, 44);

        buttonLeft = new JButton();

        buttonLeft.setName("left");
        buttonLeft.setIcon(new ImageIcon("images\\KeyLeft.png"));
        buttonLeft.setSize(48, 44);

        buttonDown = new JButton();
        buttonDown.setName("down");
        buttonDown.setIcon(new ImageIcon("images\\KeyDown.png"));
        buttonDown.setSize(48, 44);

        setSize(800,500);
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setLayout(null);

        buttonCreate.setBounds(12, 355, 170, 44);
        buttonUp.setBounds(679, 313, 48, 44);
        buttonRight.setBounds( 728, 358, 48, 44);
        buttonLeft.setBounds(630, 358, 48, 44);
        buttonDown.setBounds( 679, 358, 48, 44);
        labelCount.setBounds(12, 405, 240, 20);
        fieldCount.setBounds(210, 407, 48, 20);
        canvas.setBounds(0,0,800, 460);

        add(buttonCreate);
        add(buttonUp);
        add(buttonRight);
        add(buttonDown);
        add(buttonLeft);
        add(labelCount);
        add(fieldCount);
        add(canvas);

        buttonCreate.addActionListener(buttonCreateListener);
        buttonUp.addActionListener(buttonsMoveListener);
        buttonRight.addActionListener(buttonsMoveListener);
        buttonDown.addActionListener(buttonsMoveListener);
        buttonLeft.addActionListener(buttonsMoveListener);
    }

    ActionListener buttonCreateListener = new ActionListener() {
        public void actionPerformed(ActionEvent e) {
            int countPortholes;
            try
            {
                countPortholes = Integer.parseInt(fieldCount.getText());
            }
            catch (Exception ex)
            {
                countPortholes = 0;
            }
            if (countPortholes != 10 && countPortholes != 20 && countPortholes != 30)
            {
                JOptionPane.showMessageDialog(null, "Число должно быть равно 10, 20 или 30.\nКол-во иллюминаторов приравнено к 10");
                countPortholes = 10;
            }

            Random rand = new Random();
            _drawningAirbus = new DrawingAirbus();
            _drawningAirbus.Init(rand.nextInt(200) + 100, rand.nextInt(2000) + 1000,
                    new Color(rand.nextInt(256),rand.nextInt(256),rand.nextInt(256)),
                    new Color(rand.nextInt(256), rand.nextInt(256), rand.nextInt(256)),
                    rand.nextBoolean(), rand.nextBoolean(),
                    countPortholes,
                    canvas.getWidth(), canvas.getHeight());

            _drawningAirbus.SetPosition(rand.nextInt(100) + 10, rand.nextInt(100) + 10);
            canvas.repaint();
        }
    };

    ActionListener buttonsMoveListener = new ActionListener() {
    // реакция на нажатие
        public void actionPerformed(ActionEvent e) {
            if (_drawningAirbus == null)
            {
                return;
            }
            String command = ((JButton)(e.getSource())).getName();
            switch (command) {
            case "up":
                _drawningAirbus.MoveTransport(Direction.Up);
                break;
            case "down":
                _drawningAirbus.MoveTransport(Direction.Down);
                break;
            case "right":
                _drawningAirbus.MoveTransport(Direction.Right);
                break;
            case "left":
                _drawningAirbus.MoveTransport(Direction.Left);
                break;
            }
            canvas.repaint();
        }
    };

    class Canvas extends JComponent{
        public Canvas(){
        }
        public void paintComponent (Graphics g){
            if (_drawningAirbus == null){
                return;
            }
            super.paintComponents (g) ;
            Graphics2D g2d = (Graphics2D)g;
            _drawningAirbus.DrawTransport(g2d);
            super.repaint();
        }
    }
}
